1.2.21
 - GCC delay-slot optimizations enabled regardless of if LEON work arounds
   are enabled of not. The -fdelayed-branch optimization is application
   dependent and by generally improves instruction foot print and code execution
   slightly.
   This improvement affects UT699 and B2BST (GRLIB-TN-0009) targets (UT699e,
   UT700 and GR712RC).
 - new mfix-ut699 flag (available in GCC-4.9 and later) now enables same set of
   UT699 work-arounds as -mtune=ut699 to improve the compatibilty.

1.2.20c
 - libgcc and newlib C libraries were built unoptimized in 1.2.20 and 1.2.20b
   on Linux. This release re-enables the default "-O2 -g" on the Linux
   toolchain making it use the same build flags as the mingw toolchain.
 
1.2.20b
 - Pre-compiled LEON3 BSPs now use SPARCv7 UT699 compiler flags. The build
   flags are ISA compatible and activates all LEON3FT errata work arounds.
   The pre-built BSP libraries will now be compatible with the Cobham
   LEON3 chips (GR712RC, UT699, UT699E, UT700, RTAX) and with LEON4 too.
   Apart from build-flags update no changes in software source code.

1.2.20a
 - Fix mingw specs file. (mingw release only)

1.2.20
 - Make mcpu=v8 select same SPARCv8 multilib as -mv8 flag. 
 - B2BST Errata work around.    
    See GRLIB-TN-0009: "LEON3FT Stale Cache Entry After Store with Data
    Tag Parity Error".

1.2.19
 - new samples Makefile layout
 - GRSPW_PKT: new features and fixes,
   * added grspw_link_status_clr() to API
   * manual link error handling improvements, added link_ctrl options 
     LINKOPTS_DIS_ON_* and  LINKSTS_* and err_disconnect statistics.
   * fixed error path in DMA open.
   * fixed and improved TX/RX wait interface
   * improved closing/opening of device, user now responsible to stop and close
     DMA channels before closing the device.
   * add possibility to read descriptor table HW progress in dma_rx/tx_count()
   * Queue counters now read in sync by holding semaphore in dma_rx/tx_count()
   * Add user option to enable/disable DMA interrupt using DMAFLAG2_*
   * Split DMA semaphores into two (RX+TX). RX and TX operations on the same
     DMA channel does not block each other now.
   * updated examples and driver documentation to reflect above changes
 - AMBAPP, OCCAN: fix device registering order to match HW documentation.
 - GPTIMER start/reset takes RS and IP bits into account
 - RMAP stack: tid_msb unsigned and init allocation fixes
 - GR1553B: RT status words register declarations fix

1.2.18
 - added UT699 soft-float multilibs listed below. Before the nullify workaround
   this was not needed since all workarounds targeted FPU which soft-float
   effectivily removed. Now, when compiling for ut699 with soft-float
   mtune=ut699 must be used. This does not affect when building with hard float.
   * mtune=ut699, v8 and msoft-float
   * mtune=ut699, v7 and msoft-float
 - GRSPW: rxPktSize driver parameter fix
 - SPWTPD: new regs/bit declarations and example update

1.2.17
 - GR-RASTA-TMTC new revision1 add GRGPIO[0] register init
 - B1553BRM: change the init of the RT legalization registers
 - GRSPW_PKT: renamed grspw_status() to grspw_link_status() as defined in
   header
 - GRTM Frame Time Strobe bit declaration fix
 - Updated SPWTDP example (quick latency calculation)
 - Improvements in samples, rtems-mp and rtems-gpio

1.2.16
 - GRSPW: added clock cycles after GRSPW reset. Could cause link START
   to fail.

1.2.15
 - added SPWTDP example
 - added documentation for SPWTDP driver
 - fixed GRPCI, GRPCI2 and PCIF cfg space access to itself
 - fixed pci_print() slot0 was never printed
 - RMAP stack: added new experimental asynchonous interface
 - GRSPW-PKT: added support for new SpW Interrupt interface
 - GRSPW-PKT: fixed time control bit definitions
 - fixed -mtune=ut699 select correct toolchain multi-library, was orverrided
   by specs file to standard library.
 - added UT699 fpstore errata GCC work around

1.2.14
 - GR-RASTA-TMTC support for second version
 - GR-RASTA-IO support for third version
 - New driver for SPWTDP - SpaceWire Time Distribution Protocol

1.2.13
 - GRTIMER added support using standard GPTIMER driver
 - AT697-PCI: auto detect if host otherwise abort host bridge driver init

1.2.12
 - Toolchain: Added GCC fix for UT699 d-cache errata
 - GRETH: avoid GBit hardware generated checksum to overwrite software generated
   UDP/TCP checksum. This was a problem for IP fragments which is used by the
   NFS client for example.
 - DEVFS mknod stored path pointer, now path is copied instead. Caused
   /dev/console* file system names to be incorrect
 - Added MMU example to samples/mmu
 - GPTIMER: timer probing not hardcoded to timer0. RTEMS AMP was broken.
 - PCI:
    * Fixed IRQ routing of bus0
    * Library now scan device0 also
    * host bridge drivers updated: device numbering starts at device0 (AD16)
      instead of AD11. Accessing [0,0,0] no longer access the bridge it self.
 - fixed bug in ambapp_find_by_idx() used for finding AMBA device by Plug & Play
   index. Function worked only when finding the first device.
 - fixed APBUART tunneling debug bit that was accidentally cleared

1.2.11
 - reworked the address translation routines
 - added PCI peripheral support for NGMP prototypes
 - router-demo sample check packet count fixed

1.2.10
 - Added PCI support in the spw/router-demo sample
 - Implemented a GRPCI2-rev0 work-around in driver
 - Added GR-CPCI-LEON4-N2X (NGFP) PCI peripheral driver

1.2.9
  - RTEMS kernel upgraded to RTEMS-4.10.2. No other changes.

1.2.8
  - Fixed RASTA samples build problems
  - Added one wait-state to GR-RASTA-IO SRAM memory in samples
  - GRETH: cleanups and PHY initialization reworked
  - GRPCI1: initialize cache-line-size and latency timer. Performance increase
            due to less prefetching on DMA accesses.
  - Fixed GRSPW ioctl() commands SET_RMAPEN and SET_RMAPBUFDIS, they destroyed
    the control register by writing the content of the status register into it.
  - Updated memscrub sample

1.2.7
  - Fixed RMAP layer generating illegal "write-verify 3 bytes" command
  - GPTIMER: probe only pending bit on timer0 (probing watchdog may cause reset)
  - GPTIMER: support separate and shared interrupts at the same time by
             clearing pending bit after ISR has been called.

1.2.6
  - Fixed optimization problem with drvmgr_func_call() and GCC-4.4.6
  - Changed GRSPW and RMAP buffer alignment to 8-byte
  - Fixed various IRQ problems with SpW and AMBAPP_RMAP drvmgr bus models

1.2.5
  - Fixed declaration of GRSPW-PKT PKT_FLAG_ bit-mask, must be within 16-bits
  - SAMPLES: added grspw-test interactive SpaceWire sample
  - Bug-fixed GCC-4.4.6 -mtune=ut699 patch

1.2.4
  - APBUART: fixed GRMON -u tunneling support for older APBUARTs
  - New GRSPW/GRSPW2/GRSPW_DMA(router AMBA port) zero-copy packet based driver
    and added two examples in the samples/spw directory 
  - GPTIMER TLIB: fixed nano seconds support when timer counter underflow occurs
  - spw/router-demo SpW samples demonstrates how the MMU can be setup with RTEMS

1.2.3
  - APBUART: Fixed formula for baud rate conversion
  - GRPCI: BAR1 initailization
  - GRTM: Fix start-up timeout loop, it was optimized away

1.2.2
  - 1553 RT (ACTEL) driver: Preserve rtaddr and rtpar fields on init
  - cleanups in GRETH driver
  - Fix bug in DrvMgr dev_register

1.2.1
  - bsp_early_malloc() available in all SPARC BSPs
  - lots of cleanups, preparing for a patch submission to official tree
     - register structure names updated
     ...
  - DrvMgr DevRegister Lock handling and drvmgr_for_each_dev_breadth() bug fix
  - SpW router sample application updated
  - 1553 RT (ACTEL) driver updated: avoid hardware problem in older designs
  - fix SMC91111 IRQ setup
  - AMBAPP new helper functions (dev_count, find_by_idx)
  - fix drvmgr_for_each_dev bredth-first search bug

1.2.0 (Summary of changes compared to 1.1.1 release)
 See all changes further down in changelog.

 - New release based on RTEMS 4.10.1
 - Upgraded toolchain (GCC 4.4.6, BINUTILS 2.20.1, GDB 6.8)
 - Various bugfixes in drivers
 - Improved support for mixed OS AMP systems
 - All drivers for AMBA PnP can now be used on LEON3 and LEON2-GRLIB
 - New Driver Manager in cpukit/libdrvmgr
 - New PCI Library in cpukit/libpci
   * Improved PCI resource allocation and interrupt assignment
   * Support for multiple PCI buses (bridges)
   * Support for PCI I/O BARs
 - New drivers
   * PCIF (LEON3 and LEON2-GRLIB)
   * B1553RT
   * GRPCI for LEON2-GRLIB
   * GRPCI2 PCI Host controller driver
   * SPICTRL, with support custom chip select callback)
   * I2CMST support for multiple I2CMST cores
   * GR-RASTA-IO driver reimplemented, supports multiple boards
   * GR-RASTA-ADCDAC PCI target
   * GRADCDAC
   * GRGPIO
   * Support for multiple GRETH cores, and configurable PHY address
   * Support for GRETH on PCI targets
   * GR1553B
   * GR1553B BC
   * GR1553B BM
   * GR1553B RT
   * SPWCUC
   * GRCTM
   * GRPWM
   * MEMSCRUB driver and example in samples/memscrub directory
   * SpaceWire router PCI peripheral
   * AHBSTAT
 - All drivers from commercial release now available in free release
   * GRTM
   * GRTC
   * GR-RASTA-TMTC
   * GRSLINK
   * SATCAN
   * GRASCS
 - New GPIO Library (sparc/shared/gpio/gliblib.c)
 - New AMBA PnP layer supports more complex bus architectures, unlimited
   number of AHB masters/slaves and APB slaves.
 - Support for Bi-Directional AMBA bridge. Different AMBA Bus frequency now supported.
 - Some new samples
 - Fixed soft trap handler 3 (0x83 Window flush)
 - Added precompiled MP support, select using the -qleon3mp switch
 - APBUART driver split in two parts, console driver and APBUART driver,
   it allows multiple UART drivers to use the console layer.
 - APBUART device individual configuration of Interrupt or Polling mode and
   no need to rebuild kernel
 - APBUART driver now turns on UART TX/RX only for opened UARTs
 - Fixed APBUART driver TX interrupt mode
 - Added a simple SpaceWire RMAP Stack
 - Updated LEON3_Cpu_Index on startup to support mixed OS AMP systems, 
   changes made in Console and AMBA driver.
 - Updated GRSPW Timecode interface

1.1.99.20 (LINUX RCC-1.2 Prerelease 4)
 - fixed bug in AT697 PIO IRQ setup function
 - LEON3 MP: May wake one more CPU than expected
 - LEON3 MP: GPTIMER[0],Timer[N] default association to CPU node N
 - LEON3 MP: APBUART[N] default association to CPU node N

1.1.99.19 (LINUX RCC-1.2 Prerelease 3)
 - Built mingw toolchain for Windows
 - Fixed LEON2 AMBA PnP systems
 - Updated GRSPW Timecode interface
 - Added GRTM, GRTC and GR712 interface documentation

1.1.99.18 (LINUX RCC-1.2 Prerelease 2)
 - Fixed SMC91 interrupt handling
 - APBUART: fixed RAW mode, inherit UART parameters from loader, fix CR on NL
 - new driver for AHBSTAT and GR-RASTA-SPW-ROUTER
 - DRVMGR: updated translation routines and drivers
 - PCI peripherals: fixed bugs during conversion of RAM_START
 - libcpu: Renamed access routines from _sparc_{ld,st}* to _{ld,st}*
 - made some libpci improvements and cleanups
 - DRVMGR: coding style cleanup

1.1.99.17 (LINUX RCC-1.2 Prerelease)
 - Rebased against official RTEMS 4.10.0 sources
 - Updated tools to: GCC 4.4.5, NewLib 1.18.0, Binutils 2.20.1
   (-mtune=ut699 flag not implemented yet)
 - New PCI Library in cpukit/libpci, documentation in doc/user/libpci.t
 - Updated LEON2 & LEON3 BSPs to use libbsp/shared common shared interrupt
   implementation instead of LEON specific shared interrupt routines
 - Driver Manager updates, changes in API and cleanups
    Used script to rename code:
    sed -e 's/rtems_drvmgr_dev_info/drvmgr_dev/g' \
        -e 's/rtems_drvmgr_bus_info/drvmgr_bus/g' \
        -e 's/rtems_drvmgr_drv_info/drvmgr_drv/g' \
        -e 's/rtems_drvmgr_/drvmgr_/g' -i FILE

 - Commerical (non-free) release merged into GPL (free) release, new drivers
    * GRTM
    * GRTC
    * GR-RASTA-TMTC
    * GRSLINK
    * SATCAN
    * GRASCS
 - New shell commands: drvmgr and pci
 - examples: removed deprecated examples (spi-sdcard, httpd), added new
             rtems-shell example
 - GRPWRX: made descriptor area configurable
 - Updated GRPCI2 PCI Host driver to changes in hardware
 - fixed bug in sparc workspace area calculation (end not aligned to CPU_ALIGNMENT)
 - fixed bug in pci_bus, devices were not added correctly to the children list

1.1.99.16a
 - UT699 flag (-mtune=ut699) compiler error for stack frame > 4096 fix
 - B1553BRM: MERR IRQ was fixed, bit12 was used instead of bit 11. The 
   B1553RT ioctl() interface was also updated so that it is similar to the BRM.
 - OCCAN: Added a fix for older OCCAN cores which may loose TX IRQ status

1.1.99.16
 - New GRPCI2 PCI Host driver
 - Added 32byte debug console buffer for early debug, before UART driver has
   registered to console layer. The buffer will hopefully store the last
   printk buffer. Do "mem pre_printk_dbgbuf" from GRMON to inspect buffer.
 - fixed problem with GRCTM driver
 - added memory scrubber example driver and application
 - APBUART driver turn on UART TX/RX only for opened UARTs

1.1.99.15b
 - Fixed a PCI initialization problem

1.1.99.15a
 - Fixed APBUART driver TX interrupt mode
 - Added PnP scanning support for L2CACHE and GRIOMMU AMBA bridges

1.1.99.15
 - Fixed PCI autoconfiguration library I/O BARs on bridges
 - gcc: disable fsmuld by default
 - Added linker script for NGMP design. Add -qngmp to command line.
 - Added support for new IRQAMP Controller
 - Added GRSPW_ROUTER driver
 - added new Driver Manager APBUART console driver.
 - added new Driver Manager GPTIMER driver.
 - added --drvmgr option to configure, it makes the driver manager to be
   initialized during startup. This makes it possible for GPTIMER and APBUART
   drivers to rely on driver manager functions. Avoid this by adding -qleon3std
   when building/linking.
 - improved AMBAPP layer with frequency detection
 - smaller footprint when using driver manager.
 - bus driver configuration arrays has been made weak, this means that it is
   easier to replace the defaults.
 - GRSPW: Added support for GRSPW2_DMA (SpW-Router DMA) interface
 - GRSPW: made descriptor table base address configurable.
 - Fixed unaligned bug in GRETH driver (GBIT only fix)

1.1.99.14
 - Added UT699 flag (-mtune=ut699) to GCC compiler
 - Added GRTM descriptor table option
 - Added Watchdog stop function

1.1.99.13
 - Added option to SPICTRL so that the registers base address can be read

1.1.99.12
 - Added new drivers and examples for the drivers:
    * GR1553B
    * GR1553B BC
    * GR1553B BM
    * GR1553B RT
    * SPWCUC
    * GRCTM

1.1.99.11
 - Improved PCI autoconfiguration library when bridges are available.
 - GRPWM: updated WAVEFORM SYNC functionality (new options in HW)
 - SPICTRL: Updated the automatic perioic mode parts to new HW specification.

1.1.99.10
 - Added phyAdr option to GRETH network driver
 - Updated LEON3_Cpu_Index on startup to support mixed OS AMP systems, 
   changes made in Console and AMBA driver.
 - Fixed bug in PCI configuration Library
 - Added multiple bus support in LEON2 AT697 PCI driver
 - GRSPW: Added read timeout
 - implemented RX timeout option in RMAP stack
 - added prefix to SpaceWire bus /dev/spwbusN, this results AMBA RMAP driver
   name /dev/rmap_ADR renamed to /dev/spwbusN/rmap_ADR.

1.1.99.9
 - Added RMAP stack
 - Added RMAP stack GRSPW driver
 - Added SpaceWire Network Bus Driver Model
 - Added Generic AMBA Plug&play over SpaceWire (RMAP) Bus Driver Model
 - Added GRTC over SpaceWire driver (GRTC-RMAP)
 - Added GRTM over SpaceWire driver (GRTM-RMAP)
 - Renamed delete to remove (C++ keyword) in driver manager
 - Added optional Bus I/O register and memory access function to driver manager
 - Added support for absolute IRQ number to driver manager interrupt routines
 - Fixed deadlock bug in GRSPW driver

1.1.99.8
 - Added simple watchdog example, 
 - Updated GRPWM, SPICTRL driver to support new minor features in hardware
 - added AD7891 ADC SPI example
 - Fixed bug in GRTC driver, appeared only over PCI (GR-RASTA-TMTC)
 - Added PCI driver skeleton to rtems-pci example.

1.1.99.7
 - Changed driver manager interrupt management to handle shared interrupts,
   updated all drivers for this change.
 - Updated GRTM driver to support revision 1 of GRTM hardware (TXRDY bit moved).

1.1.99.6
 - Updated GRPWM driver according to new HW spec.

1.1.99.5
 - Fixed multiprocessor issues
 - Added rtems-mp example
 - Added support for new interrupt mask register in GRPCI driver
 - Added IGNORE option to driver manager (mostly for MP systems)
 - Added precompiled MP support, select using the -qleon3mp switch

1.1.99.4
 - Added GPIOLIB open_by_name
 - Added GR-RASTA-GRADCDAC PCI Target driver
 - Added GRADCDAC ADC/DAC Driver
 - Added support for custom SPI chip select in SPICTRL driver
 - Fixed interrupt enable/disable/clear problem in GR-RASTA-IO driver

1.1.99.3
 - Added GRPWM driver
 - Added GPIO Library
 - Added GRGPIO driver
 - Added support for multiple PCI buses and bridges
 - Added support for PCI I/O space
 - Updated SPICTRL driver to support automated periodic transfers
 - Added support for AHB/AHB Bi-directional Bridges
 - Added support for AHB/AHB Bridges with different bus frequency
 - Fixed soft trap handler 3 (0x83 Window flush)

1.1.99.0
 - New release based on RTEMS 4.9.99.0.
